VERSION 5.00
Begin VB.Form frmManifest 
   Caption         =   "Manifest by the trick"
   ClientHeight    =   7275
   ClientLeft      =   225
   ClientTop       =   855
   ClientWidth     =   8880
   Icon            =   "frmManifest.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   485
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   592
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtData 
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   9
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6975
      Left            =   180
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "frmManifest.frx":5C12
      Top             =   135
      Width           =   8535
   End
   Begin VB.Menu mnuFle 
      Caption         =   "&File"
      Begin VB.Menu mnuPatch 
         Caption         =   "&Patch..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuOpen 
         Caption         =   "Open manifest File"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "Save manifest as Default"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "Exit"
      End
   End
End
Attribute VB_Name = "frmManifest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Maded by The Trick

' fork by Alex Dragokas

' ChangeLog:

' ver. 1.3 fork:
' Added replacing of manifest file regardless of the language code of resource
' Automatically fix manifest header if there are wrong encoding specified
' Automatically add manifest header if it is not exists
' Aligns the file on a 4-byte boundary
' If file had read only attribute it will be removed
' Added icon

' ver. 1.2 fork:
' Fix for UTF-8 encoding (The Trick suggestion)
' Added menu "Open manifest file"
' Added examples of manifest file

' ver. 1.1 fork:
' 1. Added reading default manifest from file "manifest.txt"
' 2. Added menu "Save to default manifest"
' 3. Added silent mode patching throught the EXE's argument (switch -silent).
' 4. Added possibility to work throught command line.
' 5. Removed creation of a Backup for patched EXE.

Const UseSubclassing As Boolean = True

Private Declare Function CommandLineToArgvW Lib "Shell32" (ByVal lpCmdLine As Long, pNumArgs As Long) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenW" (ByVal lpString As Long) As Long
Private Declare Function lstrcpyn Lib "kernel32" Alias "lstrcpynW" (ByVal lpString1 As Long, ByVal lpString2 As Long, ByVal iMaxLength As Long) As Long
Private Declare Function GetMem4 Lib "msvbvm60" (Src As Any, Dst As Any) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, lpMultiByteStr As Any, ByVal cchMultiByte As Long, ByVal lpDefaultChar As Long, ByVal lpUsedDefaultChar As Long) As Long
Private Declare Function GetFileAttributes Lib "kernel32.dll" Alias "GetFileAttributesW" (ByVal lpFileName As Long) As Long
Private Declare Function SetFileAttributes Lib "kernel32.dll" Alias "SetFileAttributesW" (ByVal lpFileName As Long, ByVal dwFileAttributes As Long) As Long

Private Const CP_UTF8 = 65001
Private Const FILE_ATTRIBUTE_READONLY As Long = 1&

Dim isSilent As Boolean
Dim ManifestFile$

Private Sub Form_Load()
    Dim arg() As String

    ManifestFile = App.Path & "\manifest.txt"
    If Dir$(ManifestFile) <> vbNullString Then txtData.Text = ReadFile(ManifestFile)
    
    If Command() <> "" Then
        Me.Hide
        ParseCommandLine Command(), arg
        If UBound(arg) > 0 Then ' 2 . 1- -   ; 2- - 
            If InStr(1, arg(1), "silent", 1) <> 0 Then
                isSilent = True
            Else
                txtData.Text = ReadFile(arg(1))
            End If
            If UBound(arg) > 1 Then
                If InStr(1, arg(2), "silent", 1) <> 0 Then isSilent = True
            End If
        End If
        UpdateManifest arg(0)
        End
    End If
    If UseSubclassing Then lpPrevWndProc = SetWindowLong(Me.hwnd, GWL_WNDPROC, AddressOf WndProc)
End Sub
Function ReadFile(FileName As String) As String '  
    Dim ff  As Integer
    Dim s   As String
    ff = FreeFile()
    Open FileName For Binary Access Read As #ff
        s = Space(LOF(ff))
        Get #ff, , s
    Close #ff
    ReadFile = s
End Function
Private Sub Form_Resize()
    If Me.WindowState <> vbMinimized Then txtData.Move 5, 5, Me.ScaleWidth - 10, Me.ScaleHeight - 10
End Sub
Private Sub Form_Unload(Cancel As Integer)
    SetWindowLong Me.hwnd, GWL_WNDPROC, lpPrevWndProc
End Sub
Private Sub mnuExit_Click() ' 
    Unload Me
End Sub
Private Sub mnuPatch_Click() '  
    Dim fName$
    fName = GetFile(Me.hwnd, False)
    If Len(fName) Then UpdateManifest fName
End Sub
Private Sub mnuOpen_Click() '   
    Dim fName$
    fName = GetFile(Me.hwnd, True, App.Path)
    If Len(fName) Then
        Dim ff      As Integer
        Dim s       As String
        ff = FreeFile()
        Open fName For Binary Access Read As #ff
            s = Space(LOF(ff))
            Get #ff, , s
        Close #ff
        txtData.Text = s
    End If
End Sub
Private Sub UpdateManifest(fName As String)
    Dim hUpdate     As Long
    Dim ret         As Long
    Dim s           As String
    Dim out()       As Byte
    Dim l           As Long
    Dim LangCode    As Long
    Dim Attrib      As Long
    
    If Len(txtData.Text) Then
    
        Attrib = GetFileAttributes(StrPtr(fName))
        If (Attrib And FILE_ATTRIBUTE_READONLY) Then Call SetFileAttributes(StrPtr(fName), Attrib And Not FILE_ATTRIBUTE_READONLY)
    
        '       ->   
        LangCode = GetManifestLangCodeFromFile(fName)
    
        'BackupFile fName
        hUpdate = BeginUpdateResource(StrPtr(fName), False)
        If hUpdate = 0 Then ShowError " BeginUpdateResource= " & Err.LastDllError: Exit Sub
        
        txtData.Text = FixManifest(txtData.Text)
        
        ' -> To UTF8
        s = txtData.Text
        l = WideCharToMultiByte(CP_UTF8, 0, StrPtr(s), Len(s), 0, 0, 0, 0)
        ReDim out(l - 1)
        WideCharToMultiByte CP_UTF8, 0, StrPtr(s), Len(s), out(0), l, 0, 0
 
        'Remove old resource    ( NOT applicable for Windows 7 and Later !!! )
'        If LangCode <> -1 Then
'            ret = UpdateResource(hUpdate, 24, 1, LangCode, ByVal 0&, 0&)
'            ShowError "UpdateResource= " & Err.LastDllError
'        End If
        
        ret = UpdateResource(hUpdate, 24, 1, IIf(LangCode = -1, 0, LangCode), out(0), l)
        'ret = UpdateResource(hUpdate, 24, 1, 0, ByVal txtData.Text, Len(txtData.Text)) 'ANSI
        
        If ret = 0 Or 0 <> Err.LastDllError Then ShowError " UpdateResource= " & Err.LastDllError
        
        EndUpdateResource hUpdate, False
        If 0 <> Err.LastDllError Then ShowError " EndUpdateResource= " & Err.LastDllError
    End If
    If Not isSilent Then MsgBox "OK"
End Sub

Sub ShowError(ErrText As String)
    Debug.Print ErrText
    MsgBox ErrText
End Sub

Sub BackupFile(fName As String)
    Dim bName As String
    bName = fName
    Do
        bName = Left$(bName, InStrRev(bName, ".") - 1) & "_backup.exe"
    Loop Until CopyFile(StrPtr(fName), StrPtr(bName), True)     '     
    FileCopy fName, Left$(fName, InStrRev(fName, ".") - 1) & "_backup.exe"
End Sub
Private Sub mnuSave_Click()
    On Error Resume Next
    Dim ff      As Integer
    ff = FreeFile()
    Kill ManifestFile
    Open ManifestFile For Binary Access Write As #ff
        Put #ff, , txtData.Text
    Close #ff
End Sub
Private Function ParseCommandLine(Line As String, out() As String) As Boolean
    Dim ptr     As Long
    Dim count   As Long
    Dim index   As Long
    Dim strLen  As Long
    Dim strAdr  As Long
    
    ptr = CommandLineToArgvW(StrPtr(Line), count)
    If count < 1 Then Exit Function
    ReDim out(count - 1)
    For index = 0 To count - 1
        GetMem4 ByVal ptr + index * 4, strAdr
        strLen = lstrlen(strAdr)
        out(index) = Space(strLen)
        lstrcpyn StrPtr(out(index)), strAdr, strLen + 1
    Next
    GlobalFree ptr
    ParseCommandLine = True
End Function
