Attribute VB_Name = "modMain"
Option Explicit

Public Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As Long
    lpstrCustomFilter As Long
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As Long
    nMaxFile As Long
    lpstrFileTitle As Long
    nMaxFileTitle As Long
    lpstrInitialDir As Long
    lpstrTitle As Long
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type
Public Type POINTAPI
    x As Long
    y As Long
End Type
Public Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function BeginUpdateResource Lib "kernel32" Alias "BeginUpdateResourceW" (ByVal pFileName As Long, ByVal bDeleteExistingResources As Long) As Long
Public Declare Function UpdateResource Lib "kernel32" Alias "UpdateResourceW" (ByVal hUpdate As Long, ByVal lpType As Long, ByVal lpName As Long, ByVal wLanguage As Long, lpData As Any, ByVal cbData As Long) As Long
Public Declare Function EndUpdateResource Lib "kernel32" Alias "EndUpdateResourceW" (ByVal hUpdate As Long, ByVal fDiscard As Long) As Long
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameW" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function CopyFile Lib "kernel32" Alias "CopyFileW" (ByVal lpExistingFileName As Long, ByVal lpNewFileName As Long, ByVal bFailIfExists As Long) As Long

Public Const GWL_WNDPROC = &HFFFFFFFC
Public Const WM_GETMINMAXINFO = &H24

Public lpPrevWndProc As Long

'         
Public Function GetFile(ByVal hwnd As Long, isTextFile As Boolean, Optional InitDir As String) As String
    Dim ofn As OPENFILENAME
    Dim Title As String, out As String
    Dim Filter As String, i As Long
    
    ofn.nMaxFile = 260
    out = String(260, vbNullChar)
    Title = " "
    Filter = IIf(isTextFile, " " & vbNullChar & "*.txt" & vbNullChar, _
        " " & vbNullChar & "*.exe;*.dll" & vbNullChar)
    ofn.hwndOwner = hwnd
    ofn.lpstrTitle = StrPtr(Title)
    ofn.lpstrFile = StrPtr(out)
    ofn.lStructSize = Len(ofn)
    ofn.lpstrFilter = StrPtr(Filter)
    ofn.lpstrInitialDir = StrPtr(InitDir)
    
    If GetOpenFileName(ofn) Then
        i = InStr(1, out, vbNullChar, vbBinaryCompare)
        If i Then GetFile = Left$(out, i - 1)
    End If
End Function
'   ,     
Public Function WndProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case uMsg
    Case WM_GETMINMAXINFO
        Dim mm As MINMAXINFO
        CopyMemory mm, ByVal lParam, Len(mm)
        mm.ptMinTrackSize.x = 400
        mm.ptMinTrackSize.y = 400
        CopyMemory ByVal lParam, mm, Len(mm)
        Exit Function
    Case Else: WndProc = CallWindowProc(lpPrevWndProc, hwnd, uMsg, wParam, lParam)
    End Select
End Function

'    (        )
'    4- 
Public Function FixManifest(ByVal sText As String) As String
    Dim s$
    Dim pos&, pos1&, pos2&
    Dim sHead$
    Dim sOtherPart$
    Dim Rest&
    
    '         ,      :)
    
    pos = InStr(1, sText, "<?xml", 1) '  
    If pos = 0 Then
        '   
        sText = "<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?>" & vbCrLf & vbCrLf & sText
    Else
        pos = InStr(sText, "?>") '  
        
        sHead = Left$(sText, pos + 1)      ' <? ... ?>
        sOtherPart = Mid$(sText, pos + 2)   ' 
        
        pos = InStr(1, sHead, "encoding", 1)
        
        If 0 = pos Then  '   "encoding"
            sText = "<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?>" & vbCrLf & vbCrLf & sOtherPart
        Else
            pos1 = FindNearestCharEx(pos + Len("encoding"), sHead, "= " & vbCrLf)
            If Mid$(sHead, pos1, 1) = """" Then ' pos1    ?
                pos2 = InStr(pos1 + 1, sHead, """")
                pos1 = pos1 + 1 ' pos1 -    
            Else
                pos2 = FindNearestCharInc(pos1 + 1, sHead, " ?")
            End If
            If pos1 = 0 Or pos2 = 0 Then    '  - 
                sText = "<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?>" & vbCrLf & vbCrLf & sOtherPart
            Else    '      encoding
                sText = Left$(sHead, pos1 - 1) & "UTF-8" & Mid$(sHead, pos2) & sOtherPart
            End If
        End If
    End If
    
    Rest = 4 - (Len(sText) Mod 4)
    If Rest <> 0 And Rest <> 4 Then sText = sText & String$(Rest, Chr$(0))
    
    FixManifest = sText
    
End Function

'       ,     ExcludeChars
Function FindNearestCharEx(StartPos As Long, sText As String, ExcludeChars As String, Optional CompareMethod As VbCompareMethod) As Long
    Dim i&, ch$
    For i = StartPos To Len(sText)
        ch = Mid$(sText, i, 1)
        If 0 = InStr(1, ExcludeChars, ch, CompareMethod) Then FindNearestCharEx = i: Exit Function
    Next
End Function
'        
Function FindNearestCharInc(StartPos As Long, sText As String, IncludeChars As String, Optional CompareMethod As VbCompareMethod) As Long
    Dim i&, ch$
    For i = StartPos To Len(sText)
        ch = Mid$(sText, i, 1)
        If 0 <> InStr(1, IncludeChars, ch, CompareMethod) Then FindNearestCharInc = i: Exit Function
    Next
End Function
